package com.sun.s1asdev.ejb.ejb30.hello.session2.client;

import java.io.*;
import java.util.*;
import javax.ejb.EJB;
import javax.ejb.EJBException;
import javax.ejb.EJBs;
import javax.ejb.NoSuchEJBException;
import javax.ejb.EJBTransactionRequiredException;
import javax.naming.InitialContext;
import javax.naming.Context;
import com.sun.s1asdev.ejb.ejb30.hello.session2.*;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;


@EJBs( 
 { @EJB(name="ejb/TypeLevelSless1", beanName="SlessEJB", 
       beanInterface=Sless.class),
   @EJB(name="ejb/TypeLevelSless2", beanName="SlessEJB2", 
       beanInterface=Sless.class)
 })
@EJB(name="ejb/TypeLevelSless3", beanInterface=SlessSub.class)
public class Client extends ClientSuper {

    private static SimpleReporterAdapter stat = 
        new SimpleReporterAdapter("appserv-tests");

    public static void main (String[] args) {

        stat.addDescription("ejb-ejb30-hello-session2");
        Client client = new Client(args);
        client.doTest();
        stat.printSummary("ejb-ejb30-hello-session2ID");
    }  

    private static @EJB Sful sful1;

  // private static @EJB(beanName="SlessEJB") Sless sless1;

    // linked to SlessEJB2 via sun-application-client.xml 
    // so no beanName disambiguation is needed
    private static @EJB Sless sless2;

    // Only one target bean with Remote intf SlessSub so no linking info
    // necessary
  //  private static @EJB SlessSub sless3;

    public Client (String[] args) {
    }
    
    public void doTest() {

        try {

            System.out.println("****Client. before sful1.hello");
            sful1.hello();
            System.out.println("****Client. after sful1.hello");

            System.out.println("test complete");

            stat.addStatus("local main", stat.PASS);

        } catch(Exception e) {
            e.printStackTrace();
            stat.addStatus("local main" , stat.FAIL);
        }
        
    	return;
    }

}

